import { Component, OnInit, Input, Output, EventEmitter } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { FormGroup, FormBuilder, Validators } from '@angular/forms';
import { select, Store } from '@ngrx/store';
import { Observable } from 'rxjs';

import * as MemberEntityStore from '../store/entity/member';

@Component({
  selector: 'of-member-modify-password-container',
  templateUrl: './member-modify-password-container.component.html',
})
export class MemberModifyPasswordContainerComponent implements OnInit {
  @Input() token: string;
  @Output() signin = new EventEmitter();

  constructor(
    private store: Store<any>,
  ) { }

  ngOnInit() {
  }

  modifyPassword(info: {token: string, password: string, confirmPassword: string}) {
    this.store.dispatch(new MemberEntityStore.ModifyPassword(info));
  }

}
